<template lang="pug">
.flex.justify-between
  ElementUpcomingMeetings
  div
    h2 New Requests
    ul.flex.flex-col.gap-1
      li.bg-gray-100.rounded.p-2.w-96.flex.justify-between.items-center(v-for="(request, index) in appointmentRequests" :key="index")
        div.flex.flex-col
          span.font-semibold.uppercase {{getName(request.request_from)}} 
          span wants to meet you 
          span.text-sm.text-gray-500 at {{moment(request.proposed_time).format('Do MMMM YYYY, h:mm a')}}
        div.flex.flex-col.text-sm
          button.uppercase.bg-indigo-700.text-indigo-100.px-4.py-1.rounded(@click="createAppointment(request)") accept
          button.uppercase.text-indigo-700.px-4.mt-1.rounded(@click="deleteRequest(request)") cancel

</template>
<script>
import moment from 'moment'
export default {
  layout: 'caregiver',
  data: () => ({
    appointmentRequests: [],
    users: [],
    moment,
  }),
  async created() {
    this.users = await this.$api.get(`/users`).then((item) => item.users)

    const user = this.$auth.getUser()
    this.appointmentRequests = await this.$api.get(
      `/appointment/request/${user.sub}`
    )
  },
  methods: {
    getName(sub) {
      const user = this.users.find((item) => item.sub === sub)
      return user.given_name + ' ' + user.family_name
    },
    async deleteRequest(request) {
      const user = this.$auth.getUser()

      await this.$api.delete(
        `/appointment/request/${request.request_to}/${request.SK.split('#')[1]}`
      )
      this.appointmentRequests = await this.$api.get(
        `/appointment/request/${user.sub}`
      )
    },
    async createAppointment(request) {
      await this.$api.post(`/appointment`, {
        caregiver_id: request.request_to,
        patient_id: request.request_from,
        meeting_link: `https://meet.jit.si/${request.request_to}/${request.request_from}`,
        meeting_time: request.proposed_time,
      })
      this.deleteRequest(request)
    },
  },
}
</script>
